#include "HelloWorldScene.h"

CCScene* HelloWorld::scene()
{
	CCScene *scene = CCScene::node();
	HelloWorld *layer = HelloWorld::node();
	scene->addChild(layer);
	return scene;
}

/*	ʱȭ ϴ Լ	*/
bool HelloWorld::init()
{
	if ( !CCLayer::init() )		
		return false;
	
	//	 ȭ â ũ⸦ ´.
	CCSize size = CCDirector::sharedDirector()->getWinSize();
	
	//	忡   
	m_pBG = new CCSprite;
	m_pBG->initWithFile("court.png");
	m_pBG->setAnchorPoint(ccp(0, 0));
	m_pBG->setPosition(ccp(0 ,0));
	m_pBG->setScale(0.333f);
	this->addChild(m_pBG);

	m_fCom_Speed = 800.f;					//	ǻ ̵ ӵ
	m_fPlayer_Speed = MAX_SPEED - 100;		//	÷̾ ̵ ӵ
	m_fPuck_Speed = MAX_SPEED;				//	 ̵ ӵ
	m_Puck_Vec = ccp(0, 0);					//	 ̵  
	m_Com_Vec = ccp(0, 0);					//	ǻ ̵  
	
	m_Court_Range = m_pBG->boundingBox();	//	 ũ 

	const float l_offSetY = 250;			//	 ߾ӿ y   

	m_pPlayer = new CCSprite;
	m_pPlayer->initWithFile("mallet.png");
	//	÷̾ ġ ȭ ߾ Ʒʿ ġ
	m_pPlayer->setPosition(ccp(size.width / 2, size.height / 2 - l_offSetY ) );
	m_pPlayer->setScale(0.25f);
	this->addChild(m_pPlayer);

	m_pComputer = new CCSprite;
	m_pComputer->initWithFile("mallet.png");
	//	ǻ ġ ȭ ߾ ʿ ġ
	m_pComputer->setPosition(ccp(size.width / 2, size.height / 2 + l_offSetY) );
	m_pComputer->setScale(0.25f);
	this->addChild(m_pComputer);
	
	//	 ó   ǻ ġ , ߿ ǻ   ϴµ ʿ
	m_Com_Orign_pos = m_pComputer->getPosition();

	m_pPuck = new CCSprite;
	m_pPuck->initWithFile("puck.png");
	//	 ġ ȭ ߾ӿ ġ
	m_pPuck->setPosition(ccp(size.width / 2, size.height / 2 ));
	m_pPuck->setScale(0.25f);
	this->addChild(m_pPuck);

	this->schedule(schedule_selector(HelloWorld::Update));

	return true;
}

/*	ֱ Ǵ Լ	*/
void HelloWorld::Update(float dt)
{
	this->PlayerAction(dt);	//	÷̾ ̵
	
	this->ComAction(dt);	//	ǻ ̵

	this->PuckAction(dt);	//	 ̵
}

/*	 Ű Է¿  ÷̾ ̵ Ű Լ	*/
void HelloWorld::PlayerAction(float dt)
{
	CCPoint pos = m_pPlayer->getPosition();
	
	if( GetAsyncKeyState( VK_LEFT ) )
	{
		pos.x -=  m_fPlayer_Speed * dt;
	}
	if( GetAsyncKeyState( VK_DOWN ) )
	{
		pos.y -= m_fPlayer_Speed * dt;
	}
	if( GetAsyncKeyState( VK_RIGHT ) )
	{
		pos.x += m_fPlayer_Speed * dt;
	}
	if( GetAsyncKeyState( VK_UP ) )
	{
		pos.y += m_fPlayer_Speed * dt;
	}
	m_pPlayer->setPosition(pos);

	/*
		÷̾   ִ  ߾Ӽ  Ʒ ,
			xδ 0     ̰
			yδ 0     ̴.
	*/
	this->BlockObject(	m_pPlayer, 
						CCRect::CCRectGetMaxY(m_Court_Range) / 2, 
						0 );
}

/*	ǻ͸ ̵ Ű Լ	*/
void HelloWorld::ComAction(float dt)
{
	CCPoint pos = m_pComputer->getPosition();

	pos.x += m_Com_Vec.x * m_fCom_Speed * dt;
	pos.y += m_Com_Vec.y * m_fCom_Speed * dt;

	m_pComputer->setPosition(pos);

	/*
		ǻͰ   ִ  ߾Ӽ   ,
			xδ 0     ̰
			yδ          ̴.
	*/
	this->BlockObject(	m_pComputer, 
						CCRect::CCRectGetMaxY(m_Court_Range), 
						CCRect::CCRectGetMaxY(m_Court_Range) / 2 
						);
}

/*	 ̵ Ű Լ	*/
void HelloWorld::PuckAction(float dt)
{
	CCPoint pos = m_pPuck->getPosition();

	pos.x += m_Puck_Vec.x * m_fPuck_Speed * dt;
	pos.y += m_Puck_Vec.y * m_fPuck_Speed * dt;

	m_pPuck->setPosition(pos);
}

/*	
	÷̾ ǻͰ ڱ   ʰ ִ Լ
	Ű  Ʈ 忡   ִ y ̵ ̴.
*/
void HelloWorld::BlockObject(CCSprite* _pObj,float Top,float Bottom)
{
	//	÷̾ Ȥ ǻ  ġ ´.
	CCPoint pos = _pObj->getPosition();
	
	//	÷̾ Ȥ ǻ  ( ũ ġ ) ´.
	CCRect temp = _pObj->boundingBox();
	
	/*
		l_RacketMaxX  l_RacketMinX ,
		÷̾ Ȥ ǻ   Ѵ.
	*/ 
	float l_RacketMaxX = CCRect::CCRectGetMaxX( temp );
	float l_RacketMinX = CCRect::CCRectGetMinX( temp );

	//	÷̾ Ȥ ǻ   Ѵ.
	float Radius = ( l_RacketMaxX - l_RacketMinX ) / 2;
	
	/*
		Ʒ  , ǻ Ȥ ÷̾  
		ڱ ڽŵ   ϰ  κ̴.
	*/
	float ScreenLeft = CCRect::CCRectGetMinX( m_Court_Range ) + Radius;
	float ScreenRight = CCRect::CCRectGetMaxX( m_Court_Range ) - Radius;
	float ScreenTop = Top - Radius;
	float ScreenBottom = Bottom + Radius;
	
	if(ScreenLeft > pos.x )		pos.x = ScreenLeft;
	if(ScreenRight < pos.x )	pos.x = ScreenRight;
	if(ScreenTop < pos.y)		pos.y = ScreenTop;
	if(ScreenBottom > pos.y)	pos.y = ScreenBottom;
	
	_pObj->setPosition(pos);
}